program Sepia;

{ De-binhex code based rwBinHex, from Ingemar Ragnelmam }
{ OpenTransport http code based on DTS sample code by Quinn }
{ UUID generated by UUIDLib, by Bill Woody, PandaWave }

	uses
		SepiaTasks, SepiaNetwork, SepiaVersion, SepiaScript,
{$ifc REQUIRE_MP}
		MP,
{$endc}
		OpenTransport, CScriptIntf, GestaltEqu, LowMem, OSA, Lists, ColorPicker;


	const
		kSignature = 'SEPI'; { Application creator code }
		kDelayBeforeIncrease = 60 * 60; { ticks }
		kIntervalMultiplier = 10;

	var
		gApplicationResFile: Integer;
		gNetworkAvailable: Boolean;
		gSleepTicks, gWorkTicks: LongInt;
		
		gWork, gDone, gReallyQuit: Boolean;
		gMouseLoc: Point;

{ Extract from TransSkel }
	type
{	This window zooming stuff may need to be removed if you use the new Rom libraries		}
{	if not, then you can add zooming without the overhead of the new Rom libs.  See TrackBox	}
{ 	routine also.																							}

{	Window and Menu handler types, constants, variables.}

{	whList and mhList are the lists of window and menu handlers.}
{	whClobOnRmve and mhClobOnRmve are true if the handler disposal proc}
{	is to be called when a handler is removed.  They are temporarily set}
{	false when handlers are installed for windows or menus that already}
{	have handlers - the old handler is removed WITHOUT calling the}
{	disposal proc.}

{	Default lower limits on window sizing of 80 pixels both directions is}
{	sufficient to allow text windows room to draw a grow box and scroll}
{	bars without having the thumb and arrows overlap.  These values may}
{	be changed if such a constraint is undesirable with SkelGrowBounds.}
{	Default upper limits are for the Macintosh, not the Lisa, but are set}
{	per machine in SkelInit.}

	type
		WHandlerPtr = ^WHandler;
		WHandlerHnd = ^WHandlerPtr;
		WHandler = record
				whWind: WindowPtr;	{window/dialog to be handled	}
				whClobber: ProcPtr;	{ data structure disposal proc	}
				whMouse: ProcPtr;		{ mouse-click handler proc		}
				whKey: ProcPtr;		{ key-click handler proc			}
				whUpdate: ProcPtr;		{ update handler proc				}
				whActivate: ProcPtr;	{ activate event handler proc	}
				whClose: ProcPtr;		{ close "event" handler proc		}
				whIdle: ProcPtr;			{ main loop proc					}
				whEvent: ProcPtr;		{ dialog event proc				}
				whFilter: ProcPtr;		{ dialog filter proc ADDED BY INGEMAR 18/9 -93}
				whHasGrow: Boolean;	{ can window grow?				}
				whGrow: Rect;			{ limits on window sizing		}
				whSized: Boolean;		{ true = window was resized	}
				whFrontOnly: Boolean;	{ true = idle only when active	}
				whNext: WHandlerHnd;			{ next window handler			}
			end;

		MHandlerPtr = ^MHandler;
		MHandlerHnd = ^MHandlerPtr;

		MHandler = record
				mhID: integer;				{ menu id									}
				mhSelect: ProcPtr;			{ item selection handler proc			}
				mhClobber: ProcPtr;		{ menu disposal handler proc			}
				mhNext: MHandlerHnd;		{ next menu handler						}
			end;
		var
		whList: WHandlerHnd;				{ list of menu handlers }
		whClobOnRmve: Boolean;
		growRect: Rect;
		mhList: MHandlerHnd;
		mhClobOnRmve: Boolean;
{	Variables for default Apple menu handler.  appleID is set to 1 if}
{	SkelApple is called and is the id of the Apple menu, appleAboutProc}
{	is the procedure to execute if there is an About... item and it's}
{	chosen from the Apple menu.  If doAbout is true, then the menu}
{	contains the About... item, otherwise it's just desk accessories.}

		appleMenu: MenuHandle;
		appleID: integer;
		appleAboutProc: ProcPtr;
		doAbout: Boolean;
{	Miscellaneous}

{	screenPort points to the window manager port.}

{	doneFlag determines when SkelMain returns.  It is set by calling}
{	SkelWhoa(), which the host does to request a halt.}

{	pBkgnd points to a background procedure, to be run during event}
{	processing.  Set it with SkelBackground.  If nil, there's no}
{	procedure.}

{	pEvent points to an event-inspecting hook, to be run whenever an}
{	event occurs.  Set it with SkelEventHook.  If nil, there's no}
{	procedure.}

{	eventMask controls the event types requested in the GetNextEvent}
{	call in SkelMain.}

{	diskInitPt is the location at which the disk initialization dialog}
{	appears, if an uninitialized disk is inserted.}

		screenPort: GrafPtr;
		doneFlag: integer;
		pBkgnd: ProcPtr;
		pEvent: ProcPtr;
		eventMask: integer;
		diskInitPt: Point;

{Added by Ingemar 12/11-93, for WNE-support:}
		WNEImplemented: Boolean;
		sleepTicks: Longint;
		mouseRgn: rgnHandle;
{and later, for suspend/resume support:}
		gSuspendResumeHandler: ProcPtr;
		gMouseMovedHandler: ProcPtr;
{For proper handling of suspend/resume:}
		gMultiFinderAware: Boolean;

{	Events that are passed to dialogs.  Others are ignored.}
{	Standard mask passes , mousedown, keydown, autokey, update,}
{	activate and null events.  Null events are controlled by bit 0.}

		dlogEventMask: integer;
		pEventflag: Boolean;

{	"caching" global variables.  previous version would search down the window }
{	list for every event it found.  Now, if the event happened to the same window }
{	as last time, GetWDHandler will just do a simple compare }
{	and return the last window handler.  This speeds up multiple window applications }
{	immensely, at only a slight cost when you activate a new window (one }
{	compare!)  If you don't like it, use the old version. }

		oldWindow: WindowPtr;
		oldWDHandler: WHandlerHnd;

{	Global for built in "Grow Zone" function  }

		safetyHandle: Handle;

		myDitl: packed array[0..100] of byte;

{ For core apple events support /PhC 20/02/98 }
		oappProc, odocProc, pdocProc, quitProc: ProcPtr;

{ Rather than including the entire new ROM libraries, with all the other stuff you might not use	}
{ I've instead included just the Zoom box stuff here.  Depending on your status, you can either	}
{ leave things as they are, and only use zooming from the new Rom libs, or comment out the		}
{ calls, and include the new Rom libraries if you want to incorporate other new Rom calls		}


	procedure SkelSetSleep (newSleep: Longint);
	begin
		sleepTicks := newSleep;
	end;
	procedure SkelSetMouseRgn (newMouseRgn: RgnHandle);
	begin
		mouseRgn := newMouseRgn;
	end;
{	Tell SkelMain to stop}

	procedure SkelWhoa;
	begin
		doneFlag := 1;
	end;

{	Initialize the various Macintosh Managers.}
{	Set default upper limits on window sizing.}
{	FlushEvents does NOT toss disk insert events, so that disks}
{	inserted while the application is starting up don't result}
{	in dead drives.}
{	NoMasters is the number of times to call MoreMasters.  gzProc is the address of a user - provided}
{	grow zone function procedure to call if memory gets tight.  Pass nil if none to be used.	}

	procedure SkelInit (noMasters: integer; myGrowZone: ProcPtr);
		var
			i: integer;

		function CheckIfMultiFinderAware: Boolean;
			type
{The "SIZE" resource format:}
				SizeResRecord = record
						multiFinderFlags: Integer;
						preferredSize, minimumSize: Longint;
					end;
				SizeResPtr = ^SizeResRecord;
				SizeResHandle = ^SizeResPtr;
			var
				mySize: SizeResHandle;
				wasLoaded: Boolean;
		begin
			SetResLoad(false);
			mySize := SizeResHandle(Get1Resource('SIZE', -1));
			SetResLoad(true);
			if mySize = nil then
				CheckIfMultiFinderAware := false
			else begin
				wasLoaded := mySize^ <> nil;
				if not wasLoaded then
					LoadResource(Handle(mySize));

				CheckIfMultiFinderAware := true;

				if not wasLoaded then
					ReleaseResource(Handle(mySize));
			end;
		end;

	begin {SkelInit}

{ For non-Lightspeed Pascal users, the following inits are included as a compile time option, }
{  See the $SETC definition at the beginning of the unit.  }

{$IFC NOT THINK_PASCAL}
		InitGraf(@qd.thePort);
		InitFonts;
		InitWindows;
		InitMenus;
		TEInit;
		InitDialogs(nil);
		MaxApplZone;
{$ENDC}

		FlushEvents(everyEvent - diskMask, 0);
		for i := 1 to noMasters do
			MoreMasters;
		if myGrowZone <> nil then
			SetGrowZone(myGrowZone);

		InitCursor;

{Added by Ingemar 12/11-93, for WNE-support:}
		SkelSetSleep(10);
		SkelSetMouseRgn(nil);
{End WNE-support}

		whList := nil;
		whClobOnRmve := true;
		SetRect(growRect, 80, 80, 512, 342 - LMGetMBarHeight);
		mhList := nil;
		mhClobOnRmve := true;
		appleID := 0;
		appleAboutProc := nil;
		doAbout := false;
		doneflag := 0;
		pBkgnd := nil;
		pEvent := nil;
		pEventflag := false;
		eventmask := everyEvent;
		diskInitPt.v := 120;
		diskInitPt.h := 100;
		dlogEventMask := $16f;

{	Set upper limits of window sizing to machine screen size.  Allow}
{	for the menu bar.}

		GetWMgrPort(screenport);
		growRect.right := screenPort^.portRect.right;
		growRect.bottom := screenPort^.portRect.bottom - LMGetMBarHeight;

{	Set caching global variables to nil }

		oldWindow := nil;
		oldWDHandler := nil;
	end; {SkelInit}

	procedure SkelSetSuspendResume (p: ProcPtr);
	begin
		gSuspendResumeHandler := p;
	end;
	procedure CallPnoarg (myProc: ProcPtr);
	var tempUPP: UniversalProcPtr;
	begin
		tempUPP := NewDragGrayRgnUPP(DragGrayRgnProcPtr(myProc));
		InvokeDragGrayRgnUPP(tempUPP);
//		tempUPP := NewRoutineDescriptor ( @ myProc , $00000000 , GetCurrentISA );
//		dummy := CallUniversalProc ( tempUPP , $00000000 );
//		DisposeRoutineDescriptor(tempUPP);
		DisposeDragGrayRgnUPP(tempUPP);
	end;
	function CallFLongInt (l: LongInt; myProc: ProcPtr): OSErr;
	var tempUPP: UniversalProcPtr;
	begin
		tempUPP := NewOSAActiveUPP(OSAActiveProcPtr(myProc));
		CallFLongInt := InvokeOSAActiveUPP(l, tempUPP);
//		 tempUPP := NewRoutineDescriptor ( @ myProc , $000000F0 , GetCurrentISA );
//		 dummy := CallUniversalProc ( tempUPP , $000000F0 , l );
//		 CallFLongInt := OSErr ( dummy );
//		 DisposeRoutineDescriptor(tempUPP);
		DisposeOSAActiveUPP(tempUPP);
	end;
{ Added by PhC 02/98 }
	function CallFnoarg (myProc: ProcPtr): Boolean;
	var tempUPP: UniversalProcPtr;
	begin
		tempUPP := NewListClickLoopUPP(ListClickLoopProcPtr(myProc));
		CallFnoarg := InvokeListClickLoopUPP(tempUPP);
//		 tempUPP := NewRoutineDescriptor ( @ myProc , $00000010 , GetCurrentISA );
//		 dummy := CallUniversalProc ( tempUPP , $00000010 );
//		 CallFnoArg := Boolean ( dummy );
//		 DisposeRoutineDescriptor(tempUPP);
		DisposeListClickLoopUPP(tempUPP);
	end;
	function CallOtherEvent (var theEvent: EventRecord; myProc: ProcPtr): Boolean;
	var
		tempUPP: UniversalProcPtr;
	begin
		tempUPP := NewUserEventUPP(UserEventProcPtr(myProc));
		CallOtherEvent := InvokeUserEventUPP(theEvent, tempUPP);
//		tempUPP := NewRoutineDescriptor ( @ myProc , $000000D0 , GetCurrentISA );
//		dummy := CallUniversalProc ( tempUPP , $000000D0 , theEvent );
//		CallOtherEvent := Boolean ( dummy );
		DisposeUserEventUPP(tempUPP);
//		DisposeRoutineDescriptor(tempUPP);
	end;
	procedure CallPBoolean (myBool: Boolean; myProc: ProcPtr);
		var
			i1, i2, i3: Integer; { dummy variables to account for the fact that InvokeAttnRoutineUPP is not in Carbon? }
			tempUPP: UniversalProcPtr;
	begin
		tempUPP := NewSoundUPP ( SoundProcPtr ( myProc ) );
		InvokeSoundUPP ( Integer ( myBool ) , tempUPP ); (*Gr detta med Boolean?*)
//		tempUPP := NewRoutineDescriptor ( @ myProc , $00000040 , GetCurrentISA );
//		dummy := CallUniversalProc ( tempUPP , $00000040 , myBool );
//		DisposeRoutineDescriptor(tempUPP);
		tempUPP := NewQDJShieldCursorUPP(QDJShieldCursorProcPtr(myProc));
		InvokeQDJShieldCursorUPP(Integer(myBool), i1, i2, i3, tempUPP);
		DisposeQDJShieldCursorUPP(QDJShieldCursorUPP(tempUPP));
	end;
	function GetWDHandler (theWind: WindowPtr): WHandlerHnd;

		var
			h: WHandlerHnd;
	begin
{BUG FIXED by Philippe 29/6-98. This function returned garbage when passed a nil windowptr }
		h := WhList;
		GetWDHandler := nil;
		if theWind <> nil then { mod. PhC 29/06/98 }
			if theWind = oldWindow then			{  caching code 	}
				GetWDHandler := oldWDHandler
			else
				while h <> nil do
					if h^^.whWind = theWind then begin
						oldWindow := theWind;			{ Load in new values for new window }
						oldWDHandler := h;
						GetWDHandler := h;
						h := nil;
					end
					else
						h := WHandlerHnd(h^^.whNext);
	end;

{ Get Handler associated with user window.  Return nil if window doesn't}
{  have a Handler. }

	function GetWHandler (theWind: WindowPtr): WHandlerHnd;

		var
			h: WHandlerHnd;
			wKind: Integer;

	begin
{BUG FIXED by Ingemar 19/9-93. This function retured garbage when passed a dialog}
		h := GetWDHandler(theWind);
		GetWHandler := nil; {default, moved up by Ingemar}
		if h <> nil then begin
			wKind := GetWindowKind(theWind);
			if wKind <> dialogKind then
				GetWHandler := h;
		end;
	end;
	procedure DoEvent (theEvt: EventRecord);

		var
			theEvent: EventRecord;
			evtPt: Point;
			evtPort: GrafPtr;
			evtPart: integer;
			evtChar: char;
			evtMods: integer;
			h: WHandlerHnd;
			r: Rect;
			ignore: integer;

	begin
		theEvent := theEvt;
		if true then
			begin
			evtPt := theEvent.where;
			evtMods := theEvent.modifiers; {Bug fixed by Ingemar 941027 - this statement was missing}
			case theEvent.what of
				nullEvent: 
					;

{	Mouse click.  Get the window that the click occurred in, and the}
{	part of the window.	Get WDHandler is called here, not GetWHandler, since}
{	we need the handler for a window which might turn out to be a dialog window,}
{	e.g., if the click is in a close box.}

				mouseDown:  begin
					evtPart := FindWindow(evtPt, evtPort);
					h := GetWDHandler(evtPort);
					case evtPart of

{	Click in a desk accessory window.  Pass back to the system.}

						inSysWindow: 
							SystemClick(theEvent, evtPort);

{	Click in menu bar.  Track the mouse and execute selected command,}
{	if any.}

{	Click in grow box.  Resize window.}

{	Click in title bar.  Drag the window around.  Leave at least}
{	4 pixels visible in both directions.	Bug fix: The window, if not front, is}
{	selected first to make sure it's at least activated (unless the command key is down - see Inside}
{	Macintosh).  DragWindow seems to call StillDown first, so that clicks in drag regions while}
{	machine is busy don't otherwise bring window to front if the mouse is already up by the time}
{	DragWindow is called.}


{	Click in close box.  Call the close proc if the window has one.}

{	Click in content region.  If the window wasn't frontmost (active),}
{	just select it, otherwise pass the click to the window's mouse}
{	click handler.}

{	Click in zoom box.  Track the click and then zoom the window if}
{	necessary}
						otherwise
							;
					end;{mousedown}
				end;

{	Key event.  If the command key was down, process as menu item}
{	selection, otherwise pass the character and the modifiers flags}
{	to the active window's key handler.}

{	If dialogs are supported, there's no check for command-key}
{	equivalents, since that would have been checked in DoDialog.}

				keydown, autokey:  begin
				end;

{	Update a window.}

{	Activate or deactivate a window.}

{	handle inserts of uninitialized disks}


{ Handle suspend/resume and mouse moved events, added by Ingemar 23/7 -94}

				osEvt: 
					if BAND(BROTL(theEvent.message, 8), $FF) = suspendResumeMessage then begin
{Call the suspend/resume procedure, if any}
						if gSuspendResumeHandler <> nil then
							CallPBoolean(BAnd(theEvent.message, 1) <> 0, gSuspendResumeHandler);
{Added by Ingemar jan -95:}
{If we are MultiFinder aware, according to our SIZE -1, do activate or deactivate for the front window.}
					end
					else if BAND(BROTL(theEvent.message, 8), $FF) = mouseMovedMessage then
{Added by Ingemar jan -95:}
{Mouse-moved event}
						if gMouseMovedHandler <> nil then
							CallPNoArg(gMouseMovedHandler);

{ Handle Apple Events, added by Ingemar 23/7 -94}

				kHighLevelEvent: 
					ignore := AEProcessAppleEvent(theEvent);

				otherwise
					;
			end;
		end;
	end;
	function DecodeEvent (ae: AppleEvent; actionProc: ProcPtr): OSErr;
		var
			err: OSErr;
			myFSS: FSSpec;
			docList: AEDescList;
			index, itemsInList: LongInt;
			actualSize: Size;
			keywd: AEKeyword;
			returnedType: DescType;
	begin
		{ Decode the event we just received }
		err := AEGetParamDesc(ae, keyDirectObject, typeAEList, docList);
		err := AECountItems(docList, itemsInList);
		if itemsInList > 0 then
			for index := 1 to itemsInList do begin
				if err = noErr then
					err := AEGetNthPtr(docList, index, typeFSS, keywd, returnedType, @myFSS, SizeOf(myFSS), actualSize);
				if err = noErr then begin { do something with the file }
					err := CallFLongInt(LongInt(@myFSS), actionProc); { Pretend it's a longint for type-casting's sake }
				end; { if noErr }
			end; { for index }
		DecodeEvent := err;
	end; { DecodeEvent }

	function SkelHandleOAPP (var theAppleEvent: AppleEvent; var reply: AppleEvent; handlerRefCon: LongInt): OSErr;
	begin
		{$UNUSED theAppleEvent, reply, handlerRefCon}
{ Do some stuff when the application starts up.             }
{ If there is a procedure to call, do it }
		if oappProc <> nil then
			CallPNoArg(oappProc);
		SkelHandleOAPP := noErr;
	end; { SkelHandleOAPP }

	function SkelHandleODOC (var theAppleEvent: AppleEvent; var reply: AppleEvent; handlerRefCon: LongInt): OSErr;
		var
			err: OSErr;
	begin
		{$UNUSED reply, handlerRefCon}
		err := errAEEventNotHandled;
		if odocProc <> nil then  { User has given us a procedure to work with }
			err := DecodeEvent(theAppleEvent, odocProc);
		SkelHandleODOC := err;
	end; { HandleODOC }

	function SkelHandlePDOC (var theAppleEvent: AppleEvent; var reply: AppleEvent; handlerRefCon: LongInt): OSErr;
		var
			err: OSErr;
	begin
		{$UNUSED reply, handlerRefCon}
		err := errAEEventNotHandled;
		if pdocProc <> nil then  { User has given us a procedure to work with }
			err := DecodeEvent(theAppleEvent, pdocProc);
		SkelHandlePDOC := err;
	end; { SkelHandlePDOC }

	function SkelHandleQUIT (var theAppleEvent: AppleEvent; var reply: AppleEvent; handlerRefCon: LongInt): OSErr;
	begin
		{$UNUSED theAppleEvent, reply, handlerRefCon}
		SkelHandleQUIT := noErr;
{ If there is a procedure to call, do it }
		if quitProc <> nil then begin
			if not CallFNoArg(quitProc) then
				SkelHandleQUIT := userCanceledErr;
		end { if }
		else
			SkelWhoa;
	end; { SkelHandleQUIT }
	procedure SkelBackground (p: ProcPtr);
	begin
		pBkgnd := p;
	end;
 { Added by PhC 20/02/98 }
	procedure SkelReqdAEInit (myOAPP, myODOC, myPDOC, myQuit: ProcPtr);
		var
			err: OSErr;
			myHandlerUPP: AEEventHandlerUPP;
	begin
{ Set these global variables, will be used later in the appropriate AE handling procedures }
		oappProc := myOAPP;
		odocProc := myODOC;
		pdocProc := myPDOC;
		quitProc := myQUIT;

{ Install the 4 core Apple Events }
		myHandlerUPP := NewAEEventHandlerUPP(AEEventHandlerProcPtr(@SkelHandleOAPP));
		err := AEInstallEventHandler(kCoreEventClass, kAEOpenApplication, myHandlerUPP, 0, False);

		myHandlerUPP := NewAEEventHandlerUPP(AEEventHandlerProcPtr(@SkelHandleODOC));
		err := AEInstallEventHandler(kCoreEventClass, kAEOpenDocuments, myHandlerUPP, 0, False);

		myHandlerUPP := NewAEEventHandlerUPP(AEEventHandlerProcPtr(@SkelHandlePDOC));
		err := AEInstallEventHandler(kCoreEventClass, kAEPrintDocuments, myHandlerUPP, 0, False);

		myHandlerUPP := NewAEEventHandlerUPP(AEEventHandlerProcPtr(@SkelHandleQuit));
		err := AEInstallEventHandler(kCoreEventClass, kAEQuitApplication, myHandlerUPP, 0, False);

{ For some reason, if I dispose of the UPP the last element of the dispatch table won't make it... }
{		DisposePtr(Ptr(myHandlerUPP));}
	end; { SkelReqdAEInit }

	procedure SkelClobber;


	begin
		oldWDHandler := nil;
		oldWindow := nil;
		while (whList <> nil) do begin
		end;
		while (mhList <> nil) do begin
		end;
	end;
	procedure SkelMain;

		var
			theEvent: EventRecord;
			wh, wh2: WHandlerHnd;
			w: WindowPtr;
			haveEvent, testpevent: Boolean;
			tmpPort: GrafPtr;
			p: ProcPtr;

	begin
		while doneFlag = 0 do begin
			if WNEImplemented then {Added by Ingemar 12/11-93, for WNE-support:}
				begin
				if pBkgnd <> nil then
					CallPnoarg(pBkgnd);
				haveEvent := WaitNextEvent(eventMask, theEvent, sleepTicks, mouseRgn);
			end
			else begin {Old way:}
				SystemTask;
				if pBkgnd <> nil then
					CallPnoarg(pBkgnd);
				haveEvent := GetNextEvent(eventMask, theEvent);
			end;

			if pEvent <> nil then
				testpevent := CallotherEvent(theEvent, pEvent)
			else
				testpevent := false;
{ following line fixed from version 1.02 & 1.03 	[but was still buggy! /Ingemar]}
			if not testpevent then {haveEvent and <- This is wrong for modeless dialogs according to page 416? Changed by Ingemar 6/8 -93}
					DoEvent(theEvent);
			if not haveEvent then begin
				wh := whList;
				GetPort(tmpPort);
				while wh <> nil do begin
					wh2 := wh^^.whNext;
					w := wh^^.whWind;
					if ((w = FrontWindow) or not wh^^.whFrontOnly) then begin
						SystemTask;
						if (wh^^.whIdle <> nil) then begin
							SetPort(wh^^.whWind);
							p := wh^^.whIdle;
							if (p <> nil) then
								CallPnoarg(p);
						end;
					end;
					wh := wh2;
				end;
				SetPort(tmpPort);
			end;
		end;
		doneFlag := 0;
	end;
	procedure InitFlags;
	var
		err: OSStatus;
	begin
		gApplicationResFile := CurResFile;
		GetDateTime(UInt32(qd.randSeed));
		gSleepUntil := TickCount;// + RandomDelay(1, hours); { delay on startup }
		gDownloadCount := 0;
		gDone := false;
		gNetworkAvailable := true;
		gReallyQuit := false;
		gSleepTicks := kSleepTicks + RandomDelay(2, seconds);
		gWorkTicks := TickCount;
		SetPt(gMouseLoc, -1, -1);

		gTaskYield := NoYieldTask; // NoYieldTask for max speed, MPTask for multi-processor tasks, ThreadTask for Thread Manager-mediated tasks
		
		DeleteOldSepia; // Delete old version, if any
		
		gWork := true;
		
		{ Enable only 45% of clients in mlv lab: Test PhC 06/12/00 }
//		if Pos('mvlma', GetMachineName) = 1 then
//			if RandomDelay(100, ticks) > 45 then
//				gWork := false;

		err := InitCScript(gCScriptRef);
	end; { InitFlags }
	
	function InitThreads: OSErr;
	var 
	var
		err: OSErr;
		feature: LongInt;
	begin
		err := -1;
		if (kUnresolvedCFragSymbolAddress <> LongInt(@NewThread)) then { ThreadLib is loaded }
			if noErr = Gestalt(gestaltThreadMgrAttr, feature) then
				if (feature > 0) then
					err := noErr;
		InitThreads := err;
	end; { InitThreads }
	
	procedure CleanUp;
	var
		err: OSStatus;
	begin
{ Close Open Transport since we opened it at the beginning of the program }
		CloseOpenTransport;
		err := DisposeCScript(gCScriptRef);
	end; { CleanUp }

{ This is the main procedure where everything happens. Basically, we sit in a loop, handling events, }
{ and call this procedure periodically. If the gDone flag is set, we clean up our mess and bail out. }
	procedure Background;
	var
		curTicks, delayTicks: LongInt;
		junk: OSErr;
		curMouse: Point;
	begin
		curTicks := TickCount;
		
		GetMouse(curMouse);
		if EqualPt(curMouse, gMouseLoc) then begin
			{ Start increasing work if we have been idle for at least this many ticks }
			if (curTicks > (gWorkTicks + kDelayBeforeIncrease)) then begin
				SkelSetSleep(0);
			end;
		end else begin
			{ Reset everything }
			SkelSetSleep(2);
			gWorkTicks := curTicks;
			gMouseLoc := curMouse;
		end;
		
		
		delayTicks := 1 * kIntervalMultiplier;
		
		{ Big loop to avoid going back to WaitNextEvent if the machine is idle }
		repeat
			if gDone then begin
				gSleepTicks := 0; { don't sleep when we are about to quit! }
				gSleepUntil := 0;
			end;

			if (curTicks > gSleepUntil) then begin
				gSleepUntil := curTicks + gSleepTicks;
			
				case currentTask.status of
					task_none: 
						if (not gDone) then begin
							if  NetworkAvailable then begin
								if not gNetworkAvailable then begin
//									EventLog('Network is now available. Thank you!', true);
									gNetworkAvailable := true;
								end;
								if gWork then
									GetNewTaskFromServer(currentTask);
							end else begin
								if gNetworkAvailable then begin
									gNetworkAvailable := false;
//									EventLog('Network not available. Please enable TCP/IP.', true);
								end;
								gSleepUntil := RandomDelay(2, seconds); {to come back here ASAP }
							end;
						end else 
							currentTask.status := task_quitting;
					
					task_checkVersion: 
						if (not gDone) then begin
							if NetworkAvailable then begin
//								EventLog('Checking for a more recent version of Sepia', true);
								GetVersionFromServer(currentTask);
							end else
								currentTask.status := task_none;
						end else 
							currentTask.status := task_quitting;
					
					task_compareVersion: 
						if (not gDone) then begin
							if DifferentVersion(currentTask.name, gSepiaVersion) then begin // use kSepiaVersion for current version info, or kSepiaDontCheckVersion to avoid this check
								if ChangeMyName then begin
//									EventLog(StringOf('Version ', currentTask.name, ' is available. Downloading'), true);
									DownloadNewVersionFromServer(currentTask);
								end; { if ChangeMyName }
							end else begin
								currentTask.status := task_none;
								gSleepUntil := RandomDelay(2, seconds);
							end;
						end else 
							currentTask.status := task_quitting;
					
					task_startNewVersion:
						if (not gDone) then begin
							if StartNewVersion then begin
								currentTask.status := task_quitting;
								gSleepUntil := 0; { do this now! }
							end; { if StartNewVersion }
						end else 
							currentTask.status := task_quitting;
					
					
					task_new:
						if gDone then begin
							if NetworkAvailable then 
								ClearTask(currentTask);
						end else begin
							if HaveAlgorithm(currentTask.name) then
								LaunchTask(currentTask)
							else
								RetrieveLibraryFromServer(currentTask);
						end; { else }
					
					task_inProgress: 
						if gDone then begin
							if NetworkAvailable then 
								ClearTask(currentTask);
						end else begin
							UpdateProgress(currentTask);
						end;
					
					task_done: 
						if NetworkAvailable then begin
							if gDone then
								ClearTask(currentTask)
							else
								SendTaskToServer(currentTask);
						end else 
							currentTask.status := task_quitting;
					
					task_transferInProgress: 
						if NetworkAvailable then
							if gDone then
								ClearTask(currentTask);
					
					task_clearing: { wait for the task to be deleted from server }
						if gReallyQuit then
							currentTask.status := task_quitting;
					
					task_quitting:
						SkelWhoa;
					
					otherwise
						;
				end; { case }
			
			end; { if }
			
			junk := YieldToAnyThread;

		until (TickCount > curTicks + delayTicks);

	end; {Background}

	procedure DoSuspendResume (isResume: Boolean);
	begin
		if isResume then
			SkelSetSleep(0)
		else
			SkelSetSleep(10);
	end;
	
	procedure StartupComplete;
	var
		s: Str255;
	begin
		s := Concat('Sepia version ', gSepiaVersion, ' startup completed');
//		EventLog(s, true);
		NumToString((gSleepUntil - TickCount) div 60, s);
		s := Concat('Sleeping for ', s , ' seconds for server performance');
//		EventLog(s, true);
	end; { StartupComplete }

	function DoQuit: OSErr;
	begin
		if not gDone then begin
			gDone := true; { we're done here }
//			EventLog('Quit command received', true);
		end else begin {quit and abort everything ('really' quit) }
			if not gReallyQuit then begin
				gReallyQuit := true;
//				EventLog('Quitting now without confirmation', true);
			end;
		end;
		DoQuit := noErr;
	end; { DoQuit }

begin
{ Initialisations }
	SkelInit(6, nil);
	
	{ Vrifications des composantes ncessaires }
	if (InitOpenTransport <> noErr) then
		{DeathAlert(errOTRequired, 1)};
	
{$ifc REQUIRE_MP}
	if not MPLibraryIsLoaded then
		DeathAlert(errMPLibraryRequired, 1);
{$endc}
	
	if (InitThreads <> noErr) then
		{DeathAlert(errThreadManagerRequired, 1)};

	InitFlags;

	SkelSetSuspendResume(@DoSuspendResume);
	SkelBackground(@Background);
	DoSuspendResume(true); { we are in the foreground }
	SkelReqdAEInit(nil, nil, nil, @DoQuit);
	
	InitTask(currentTask);

	StartupComplete;

	SkelMain;												{ loop til quit selected, or 'quit' AE is received }
	
	CleanUp;
	
	SkelClobber;											{ clean up application }

end.