#include <OSUtils.h>
#include <QDOffscreen.h>
#include <Resources.h>
#include <Notification.h>
#include <Gestalt.h>
#include <Palettes.h>
#include <Traps.h>
#include "Crrrhaaack.h"
#include "A4Code.h"

long		gRealNewGDevice;
long		gRealGetDeviceList;
long		gRealInitGraf;
NMRec		gAVFixRec;
CrunchData	gData;

/* --------------------------------------------------------------------------------	*/
pascal GDHandle NewGDevicePatch(short refNum, long mode)
{
	pascal GDHandle		(*callThrough)(short, long);
	GDHandle			result;
	
	EnterCodeResource();
	callThrough = (pascal GDHandle	(*)(short, long))gRealNewGDevice;
	result = callThrough(refNum, mode);
	if(result && TestDeviceAttribute(result, screenDevice))
	{
		(**result).gdRect = gData.screenRect;
	}
	
	ExitCodeResource();
	return result;
}

/* --------------------------------------------------------------------------------	*/
pascal GDHandle GetDeviceListPatch(void)
{
	pascal GDHandle		(*callThrough)(void);
	GDHandle			result;
	
	EnterCodeResource();
	callThrough = (pascal GDHandle	(*)(void))gRealGetDeviceList;
	result = callThrough();
	if(result && TestDeviceAttribute(result, screenDevice))
	{
		(**result).gdRect = gData.screenRect;
	}
	
	ExitCodeResource();
	return result;
}

/* --------------------------------------------------------------------------------	*/
pascal void InitGrafPatch(Ptr ptr)
{
	pascal void		(*callThrough)(Ptr);
	BitMap			*screenBitsPtr;
	long			oldA5;
	
	EnterCodeResource();
	callThrough = (pascal void	(*)(Ptr))gRealInitGraf;
	callThrough(ptr);
	oldA5 = SetCurrentA5();
	screenBitsPtr = (BitMap *)oldA5 - 658;
	screenBitsPtr->bounds = gData.screenRect;
	SetA5(oldA5);
	ExitCodeResource();
}

/* --------------------------------------------------------------------------------	*/
pascal void DeviceLoopProc(short depth, short flags, GDHandle device, long data)
{
	SetDepth(device, 8, 1, 1);
	SetDepth(device, depth, 1, 1);
}

/* --------------------------------------------------------------------------------	*/
pascal void AVFixResponse(NMRecPtr myRec)
{
	EnterCodeResource();
	NMRemove(myRec);
	DeviceLoop(NULL, DeviceLoopProc, 0L, allDevices);
	ExitCodeResource();
}

/* --------------------------------------------------------------------------------	*/
pascal OSErr CrunchSelector(OSType selector, long *response)
{
	EnterCodeResource();
	*response = (long)&gData;
	ExitCodeResource();
	return noErr;
}

/* --------------------------------------------------------------------------------	*/
void main(void)
{
	EnterCodeResource();
	RememberA4();
	
	gRealNewGDevice = (long)NGetTrapAddress(_NewGDevice, ToolTrap);
	NSetTrapAddress((ProcPtr)NewGDevicePatch, _NewGDevice, ToolTrap);
	
	gRealGetDeviceList = (long)NGetTrapAddress(_GetDeviceList, ToolTrap);
	NSetTrapAddress((ProcPtr)GetDeviceListPatch, _GetDeviceList, ToolTrap);
	
	// Don't really need this, and don't have time to mess with it.
	// gRealInitGraf = (long)NGetTrapAddress(_InitGraf, ToolTrap);
	// NSetTrapAddress((ProcPtr)InitGrafPatch, _InitGraf, ToolTrap);
	
	gAVFixRec.qType = nmType;
	gAVFixRec.nmMark = 0;
	gAVFixRec.nmIcon = NULL;
	gAVFixRec.nmSound = NULL;
	gAVFixRec.nmStr = NULL;
	gAVFixRec.nmResp = AVFixResponse;
	NMInstall(&gAVFixRec);

	SetRect(&gData.screenRect, 0, 0, 1024, 260);
	NewGestalt(kCrunchCreator, CrunchSelector);

	DetachResource(GetResource('INIT', 0));

	ExitCodeResource();
}
