// ===========================================================================
//	CF1HackApp.cp		   1996-1998 Metrowerks Inc. All rights reserved.
// ===========================================================================

#ifdef PowerPlant_PCH
#include PowerPlant_PCH
#endif

#include "CF1HackApp.h"
#include "AppleFunctionIndex.h"

#include	<stdio.h>
#include	<string.h>
#include	<Marklib.h>
#include	<LThread.h>
#include	<LCleanupTask.h>

#include <AEObjects.h>
#include <OSUtils.h>

//Use this to tune the tick delay of the LYieldAttachment
#define kAppYieldQuantum -1

#define PP_NewClasses 1

// ===========================================================================
//		 Main Program
// ===========================================================================

void main(void)
{
									// Set Debugging options
//	SetDebugThrow_(debugAction_Alert);
//	SetDebugSignal_(debugAction_Alert);

	InitializeHeap(3);				// Initialize Memory Manager
									// Parameter is number of Master Pointer
									//   blocks to allocate
	
									// Initialize standard Toolbox managers
#if PP_Target_Carbon
	UQDGlobals::InitializeToolbox();
#else
	UQDGlobals::InitializeToolbox(&qd);
#endif

	if (UEnvironment::HasFeature(env_HasThreadsManager))
		new UMainThread;
	
	new LGrowZone(20000);			// Install a GrowZone function to catch
									//    low memory situations.

	CF1HackApp	theApp;			// replace this with your App type
	theApp.Run();

	LCleanupTask::CleanUpAtExit();
}


// ---------------------------------------------------------------------------
//		 CF1HackApp
// ---------------------------------------------------------------------------
//	Default Constructor

CF1HackApp::CF1HackApp()
{
	
	// Add a yield attachment.
	AddAttachment(new LYieldAttachment(kAppYieldQuantum));
	fLaunchTime = TickCount();
}

// ---------------------------------------------------------------------------
//		 ~CF1HackApp
// ---------------------------------------------------------------------------
//	Destructor

CF1HackApp::~CF1HackApp()
{
}

// ---------------------------------------------------------------------------
//		 StartUp
// ---------------------------------------------------------------------------
//	This function lets you do something when the application starts up. 
//	For example, you could issue your own new command, or respond to a system
//  oDoc (open document) event.

void
CF1HackApp::StartUp()
{
}

// ---------------------------------------------------------------------------
//		 ObeyCommand
// ---------------------------------------------------------------------------
//	Respond to commands

Boolean
CF1HackApp::ObeyCommand(
	CommandT	inCommand,
	void		*ioParam)
{
	Boolean		cmdHandled = true;

	switch (inCommand)
	{
		default:
			cmdHandled = LApplication::ObeyCommand(inCommand, ioParam);
			break;
	}
	
	return cmdHandled;
}


// ---------------------------------------------------------------------------
//		 FindCommandStatus
// ---------------------------------------------------------------------------
//	Pass back the status of a Command

void
CF1HackApp::FindCommandStatus(
	CommandT	inCommand,
	Boolean		&outEnabled,
	Boolean		&outUsesMark,
	UInt16		&outMark,
	Str255		outName)
{
	switch (inCommand) {
	
		case cmd_New:
		case cmd_Open:
			outEnabled = false;
			break;
			
		default:
			LApplication::FindCommandStatus(inCommand, outEnabled,
									outUsesMark, outMark, outName);
			break;
	}
}

void CF1HackApp::HandleAppleEvent(
	const AppleEvent&	inAppleEvent,
	AppleEvent&			outAEReply,
	AEDesc&				outResult,
	long				inAENumber)
{
	switch (inAENumber)
	{
		case 5435:
		{
			StAEDescriptor	targD (inAppleEvent, keyDirectObject, 'TEXT');
			char			text[1024];
			Handle			h = (Handle) targD.mDesc.dataHandle;
			int				len = GetHandleSize(h);
			char			*c;
			HLock (h);
			c = * (char **) h;
			memcpy (text, c, len);
			text[len] = 0;
			
			AppleFunctionIndexThread::Start (text);
			
			fLaunchTime = TickCount();
			break;
		}	
		default:
			LApplication::HandleAppleEvent (inAppleEvent, outAEReply, outResult, inAENumber);
			break;
	}
}

void	CF1HackApp::ProcessNextEvent()
{
	LApplication::ProcessNextEvent();

	unsigned long	now = TickCount();
	
	if ((now - fLaunchTime) > 120)
	{
		this->SendAEQuit();
	}
	
}
