#import "PageController.h"

@implementation PageController

//#define PYSCRIPT @"Users/paul/Documents/fido.py"
#define PYSCRIPT @"./fido.py"
#define MAXLENGTH 160

- (void)textDidChange:(NSNotification *)aNotification
{
    int myLen;
    
    myLen = [[senderName stringValue] length] + [[messageText stringValue] length];
    
    [messageLength setIntValue: myLen];
}

- (void) awakeFromNib
{
    [self textDidChange:nil];

    [[NSNotificationCenter defaultCenter] addObserver:self
	selector:@selector(textDidChange:)
	name:NSTextDidChangeNotification
	object:nil];
}

- (IBAction)SendPage:(id)sender
{
    int myLen;
   
    myLen = [[senderName stringValue] length] + [[messageText stringValue] length];
    
    if ( myLen > MAXLENGTH ) {
	
	//APPKIT_EXTERN void NSBeginAlertSheet(NSString *title, NSString *defaultButton, NSString *alternateButton, NSString *otherButton, NSWindow *docWindow, id modalDelegate, SEL didEndSelector, SEL didDismissSelector, void *contextInfo, NSString *msg, ...);

	NSBeginAlertSheet(@"Message Length Problem",
	@"Okay",
	nil,
	nil,
	[sender window],
	self,
	NULL,
	NULL,
	sender,
	@"Your page is too long. It cannot exceed 160 characters.",
	nil);
	
	
    } else {

	NSTask *pageTask = [[NSTask alloc] init];
	NSMutableArray *args = [NSMutableArray array];
	    
	/* set arguments */
	[args addObject:[senderName stringValue]];
	[args addObject:[phoneNumber stringValue]];
	[args addObject:[messageText stringValue]];
	NSLog (@"%@",args);
	[pageTask setLaunchPath:PYSCRIPT];
	[pageTask setArguments:args];
	[pageTask launch];

	
    }
}

- (IBAction)updateLength:(id)sender
{
}

@end
