// drawing.h

#define PILOT_PRECOMPILED_HEADERS_OFF
#include <Pilot.h>


// alignment constants
enum h_align { left_align, center_align, right_align };
enum v_align { top_align, middle_align, bottom_align, baseline_align };

// prototypes
void 		draw_bitmap(int resID, int x, int y, h_align h, v_align v, ScrOperation copy_mode=scrCopy);
void 		draw_bitmap_masked(int bitmapID, int maskID, int x, int y, h_align h, v_align v);
void 		draw_string(const char* s, int x, int y, h_align h, v_align v);
void 		draw_char(char c, int x, int y, h_align h, v_align v);
void		erase_rect(int x, int y, int width, int height);
void		paint_rect(int x, int y, int width, int height);
void		draw_bits(BitmapPtr in_bits, int x, int y, ScrOperation copy_mode);

Boolean	point_is_close(int x1, int y1, int x2, int y2, int slop);
void		get_bitmap_dimensions(int resID, int& height, int& width);
void		constrain_to_screen (short& x, short& y);