// da_mgr.cp

#include "da_mgr.h"
#include "events.h"
#include "view.h"

#include "da_alarm_clock.h"

//
// Constructor
//
da_mgr::da_mgr (view* in_superview)
{
	m_superview = in_superview;
	m_alarm_clock = NULL;
}


//
// Destructor
//
da_mgr::~da_mgr ()
{
	if (m_alarm_clock != NULL)
		delete m_alarm_clock;
}

//
// open_alarm_clock
//
void
da_mgr::open_alarm_clock ()
{
	commander*	supercommander = commander::get_top_commander();
	
	if (m_alarm_clock==NULL)
		new da_alarm_clock (supercommander, m_superview);
}


//
// open_calculator
//
void
da_mgr::open_calculator ()
{
	sys_beep (1000);
}

//
// open_chooser
//
void
da_mgr::open_chooser ()
{
	sys_beep (1000);
}

//
// open_control_panel
//
void
da_mgr::open_control_panel ()
{
	sys_beep (1000);
}

//
// open_key_caps
//
void
da_mgr::open_key_caps ()
{
	sys_beep (1000);
}

//
// open_note_pad
//
void
da_mgr::open_note_pad ()
{
	sys_beep (1000);
}

//
// open_scrapbook
//
void
da_mgr::open_scrapbook ()
{
	sys_beep (1000);
}

