// icon.h

#include "pane.h"
#include "commander.h"

class icon: public pane, public commander {
public:
							icon (int in_bitmapID, 
									int in_maskID, 
									const char* in_name, 
									int x, int y, 
									view* in_superview);
	virtual				~icon();

	void					get_position (int& x, int& y);
	void					select();
	void					deselect();
	void					set_icon (int in_bitmapID, int in_maskID, Boolean in_redraw);
	
protected:
	char					m_name[256];
	int					m_bitmapID;
	int					m_maskID;
	int					m_x, m_y;
	Boolean				m_selected;
	
							// overriding view methods
	virtual void		draw_self();
	virtual Boolean	click_self(int x, int y);

							// overriding commander methods
	virtual Boolean	do_cmd_self (int in_eventID, void* io_data);
	
							// icon methods
	void					recalculate_rect();
	void					get_name_rect( RectangleType* r );
	void					get_bitmap_rect( RectangleType* r );
};