// view.cpp

#include "view.h"


// 
// constructor
//
view::view(RectangleType* in_bounds, view* in_superview):
	pane(in_bounds, in_superview)
{
	m_subpanes = NULL;
}

// 
// constructor
//
view::view(view* in_superview):
	pane(in_superview)
{
	m_subpanes = NULL;
}

// 
// default constructor
//
view::view():
	pane()
{
	m_subpanes = NULL;
}


//
// destructor
//
view::~view() {
	if (m_subpanes!=NULL)
		delete m_subpanes;
}


#pragma mark -


//
// draw()
//
void		
view::draw(){
	pane::draw();
	if (m_subpanes!=NULL)
		m_subpanes->draw();
}

//
// click()
//
Boolean	
view::click(int x, int y) {
	Boolean handled = false;
	
	if (m_subpanes!=NULL)
		handled = m_subpanes->click (x, y);
	if (not handled)
		handled = pane::click (x, y);
	
	return handled;
}

//
// still_down()
//
Boolean	
view::still_down(int x, int y) {
	Boolean handled = false;
	
	if (m_subpanes!=NULL)
		handled = m_subpanes->still_down (x, y);
	if (not handled)
		handled = pane::still_down (x, y);

	return handled;
}

//
// pen_up()
//
Boolean	
view::pen_up(int x, int y) {
	Boolean handled = false;
	
	if (m_subpanes!=NULL)
		handled = m_subpanes->pen_up (x, y);
	if (not handled)
		handled = pane::pen_up (x, y);

	return handled;
}

//
// idle()
//
void
view::idle() {
	pane::idle();
	if (m_subpanes!=NULL)
		m_subpanes->idle();
}

