#
#	File:		LateImportTest.c
#
#	Contains:	MPW build instructions for the LateImportTest program.
#
#	Written by:	Quinn
#
#	Copyright:	Copyright  1999 by Apple Computer, Inc., all rights reserved.
#
#				You may incorporate this Apple sample source code into your program(s) without
#				restriction. This Apple sample source code has been provided "AS IS" and the
#				responsibility for its operation is yours. You are not permitted to redistribute
#				this Apple sample source code as "Apple sample source code" after having made
#				changes. If you're going to re-distribute the source, we require that you make
#				it clear in the source that the code was descended from Apple sample source
#				code, but that you've made changes.
#
#	Change History (most recent first):
#
#        <1>     17/1/00    Quinn   First checked in.
#

#
#	{MoreIsBetter} must be set to the root of the MoreIsBetter source hierarchy.
#	{MIBInterfaces} must be set to the MoreIsBetter Universal Interfaces.
#	{MIBStubLibraries} must be set to the MoreIsBetter stub libraries.
#

#	Locate the CFMLateImport directory within MIB.

CFMLateImportDir = {MoreIsBetter}MIB-Libraries:MoreCodeFragments:CFMLateImport:

#	Locate the objects directory within MIB.

ObjectsDir = {MoreIsBetter}MIB-Libraries:MoreCodeFragments:CFMLateImport:Objects:

#	Set up some standard variables.

COpts = 
	-traceback 											# we *always* want traceback tables (-: 
	-i "{MIBInterfaces}" 								# for all the Universal Interfaces 
	-i "{MoreIsBetter}"MIB-Libraries: 					# for MoreSetup.h 
	-i "{MoreIsBetter}"MIB-Libraries:MoreInterfaceLib: 	# for MoreInterfaceLib.h 
	-i "{CFMLateImportDir}"				 				# for CFMLateImport.h 
	-i "{CFMLateImportDir}"LateImportTest:TestLibrary: 	# for TestLibrary.h 
	-i "{CIncludes}"									# Standard MPW ANSI C stuff

#	Start with the high-level target.

LateImportTest		
		"{CFMLateImportDir}"LateImportTest:LateImportTest-PPC-MPW
	
#	To build LateImportTest-PPC-MPW, we need to link the corresponding .o file
#	and Rez in SIOW.

"{CFMLateImportDir}"LateImportTest:LateImportTest-PPC-MPW  
		"{ObjectsDir}"LateImportTest.c.o 
		"{ObjectsDir}"CFMLateImport.c.o 
		"{ObjectsDir}"MoreInterfaceLib.c.o 
		"{PPCLibraries}"PPCSIOW.o 
		"{PPCLibraries}"PPCCRuntime.o 
		"{SharedLibraries}"StdCLib 
		"{MIBStubLibraries}"InterfaceLib 
		"{CFMLateImportDir}"LateImportTest:TestLibrary:TestLibrary.stub
	PPCLink 
		{deps} 
		-xm executable 									# build an application 
		-o {targ}	 									# named LateImportTest-PPC-MPW 
		-weaklib TestLibrary						 	# weak link with our stub library 
		-init MyCFragInitFunction						# specify the fragment initialization function 
		-packdata off									# CFMLateImport requires unpacked data sections

"{CFMLateImportDir}"LateImportTest:LateImportTest-PPC-MPW  
		"{RIncludes}"SIOW.r
	Rez {deps} -append -o {targ}

#	To build LateImportTest.c.o, we need to compile the corresponding .c file.

"{ObjectsDir}"LateImportTest.c.o 	
		"{CFMLateImportDir}"LateImportTest:LateImportTest.c
	MrC {deps} 
		{COpts} 
		-o "{ObjectsDir}"

"{CFMLateImportDir}"LateImportTest:LateImportTest.c  
	"{CFMLateImportDir}"LateImportTest:TestLibrary:TestLibrary.h

#	To build CFMLateImport.c.o, we need to compile the corresponding .c file.

"{ObjectsDir}"CFMLateImport.c.o 	
		"{CFMLateImportDir}"CFMLateImport.c
	MrC {deps} 
		{COpts} 
		-o "{ObjectsDir}"

#	To build CFMLateImport.c.o, we need to compile the corresponding .c file.

"{ObjectsDir}"MoreInterfaceLib.c.o 	
		"{MoreIsBetter}"MIB-Libraries:MoreInterfaceLib:MoreInterfaceLib.c
	MrC {deps} 
		{COpts} 
		-o "{ObjectsDir}"
